# coding: utf-8

"""
    FINBOURNE Identity Service API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic.v1 import validate_arguments, ValidationError
from typing import overload, Optional, Union, Awaitable

from typing_extensions import Annotated
from datetime import datetime

from pydantic.v1 import Field, StrictStr, conint, constr

from typing import Optional

from finbourne_identity.models.resource_list_of_system_log import ResourceListOfSystemLog

from finbourne_identity.api_client import ApiClient
from finbourne_identity.api_response import ApiResponse
from finbourne_identity.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)
from finbourne_identity.extensions.configuration_options import ConfigurationOptions

# ensure templated type usages are imported
from pydantic.v1 import Field, StrictStr
from typing import Optional
from typing_extensions import Annotated

class IdentityLogsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @overload
    async def list_logs(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_filter : Annotated[Optional[StrictStr], Field( description="Okta filter expression")] = None, okta_query : Annotated[Optional[StrictStr], Field( description="Filters log events results by one or more case insensitive keywords")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, **kwargs) -> ResourceListOfSystemLog:  # noqa: E501
        ...

    @overload
    def list_logs(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_filter : Annotated[Optional[StrictStr], Field( description="Okta filter expression")] = None, okta_query : Annotated[Optional[StrictStr], Field( description="Filters log events results by one or more case insensitive keywords")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, async_req: Optional[bool]=True, **kwargs) -> ResourceListOfSystemLog:  # noqa: E501
        ...

    @validate_arguments
    def list_logs(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_filter : Annotated[Optional[StrictStr], Field( description="Okta filter expression")] = None, okta_query : Annotated[Optional[StrictStr], Field( description="Filters log events results by one or more case insensitive keywords")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, async_req: Optional[bool]=None, **kwargs) -> Union[ResourceListOfSystemLog, Awaitable[ResourceListOfSystemLog]]:  # noqa: E501
        """[BETA] ListLogs: Lists system logs for a domain  # noqa: E501

        Lists system logs for a domain  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_logs(okta_since, okta_until, okta_filter, okta_query, okta_limit, okta_sort_order, okta_after, async_req=True)
        >>> result = thread.get()

        :param okta_since: Lower bound of log events published property
        :type okta_since: datetime
        :param okta_until: Upper bound of log events published property
        :type okta_until: datetime
        :param okta_filter: Okta filter expression
        :type okta_filter: str
        :param okta_query: Filters log events results by one or more case insensitive keywords
        :type okta_query: str
        :param okta_limit: Max number of results returned
        :type okta_limit: int
        :param okta_sort_order: Order of events by published property. Either ASCENDING or DESCENDING
        :type okta_sort_order: str
        :param okta_after: Okta Page token
        :type okta_after: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: Timeout setting. Do not use - use the opts parameter instead
        :param opts: Configuration options for this request
        :type opts: ConfigurationOptions, optional
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ResourceListOfSystemLog
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the list_logs_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.list_logs_with_http_info(okta_since, okta_until, okta_filter, okta_query, okta_limit, okta_sort_order, okta_after, **kwargs)  # noqa: E501

    @validate_arguments
    def list_logs_with_http_info(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_filter : Annotated[Optional[StrictStr], Field( description="Okta filter expression")] = None, okta_query : Annotated[Optional[StrictStr], Field( description="Filters log events results by one or more case insensitive keywords")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """[BETA] ListLogs: Lists system logs for a domain  # noqa: E501

        Lists system logs for a domain  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_logs_with_http_info(okta_since, okta_until, okta_filter, okta_query, okta_limit, okta_sort_order, okta_after, async_req=True)
        >>> result = thread.get()

        :param okta_since: Lower bound of log events published property
        :type okta_since: datetime
        :param okta_until: Upper bound of log events published property
        :type okta_until: datetime
        :param okta_filter: Okta filter expression
        :type okta_filter: str
        :param okta_query: Filters log events results by one or more case insensitive keywords
        :type okta_query: str
        :param okta_limit: Max number of results returned
        :type okta_limit: int
        :param okta_sort_order: Order of events by published property. Either ASCENDING or DESCENDING
        :type okta_sort_order: str
        :param okta_after: Okta Page token
        :type okta_after: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: Timeout setting. Do not use - use the opts parameter instead
        :param opts: Configuration options for this request
        :type opts: ConfigurationOptions, optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ResourceListOfSystemLog, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'okta_since',
            'okta_until',
            'okta_filter',
            'okta_query',
            'okta_limit',
            'okta_sort_order',
            'okta_after'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers',
                'opts'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_logs" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('okta_since') is not None:  # noqa: E501
            if isinstance(_params['okta_since'], datetime):
                _query_params.append(('oktaSince', _params['okta_since'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('oktaSince', _params['okta_since']))

        if _params.get('okta_until') is not None:  # noqa: E501
            if isinstance(_params['okta_until'], datetime):
                _query_params.append(('oktaUntil', _params['okta_until'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('oktaUntil', _params['okta_until']))

        if _params.get('okta_filter') is not None:  # noqa: E501
            _query_params.append(('oktaFilter', _params['okta_filter']))

        if _params.get('okta_query') is not None:  # noqa: E501
            _query_params.append(('oktaQuery', _params['okta_query']))

        if _params.get('okta_limit') is not None:  # noqa: E501
            _query_params.append(('oktaLimit', _params['okta_limit']))

        if _params.get('okta_sort_order') is not None:  # noqa: E501
            _query_params.append(('oktaSortOrder', _params['okta_sort_order']))

        if _params.get('okta_after') is not None:  # noqa: E501
            _query_params.append(('oktaAfter', _params['okta_after']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "ResourceListOfSystemLog",
            '400': "LusidValidationProblemDetails",
        }

        return self.api_client.call_api(
            '/api/logs', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            opts=_params.get('opts'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))


    @overload
    async def list_user_logs(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, **kwargs) -> ResourceListOfSystemLog:  # noqa: E501
        ...

    @overload
    def list_user_logs(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, async_req: Optional[bool]=True, **kwargs) -> ResourceListOfSystemLog:  # noqa: E501
        ...

    @validate_arguments
    def list_user_logs(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, async_req: Optional[bool]=None, **kwargs) -> Union[ResourceListOfSystemLog, Awaitable[ResourceListOfSystemLog]]:  # noqa: E501
        """[BETA] ListUserLogs: Lists user logs  # noqa: E501

        Lists account related system logs for the calling user  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_user_logs(okta_since, okta_until, okta_limit, okta_sort_order, okta_after, async_req=True)
        >>> result = thread.get()

        :param okta_since: Lower bound of log events published property
        :type okta_since: datetime
        :param okta_until: Upper bound of log events published property
        :type okta_until: datetime
        :param okta_limit: Max number of results returned
        :type okta_limit: int
        :param okta_sort_order: Order of events by published property. Either ASCENDING or DESCENDING
        :type okta_sort_order: str
        :param okta_after: Okta Page token
        :type okta_after: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: Timeout setting. Do not use - use the opts parameter instead
        :param opts: Configuration options for this request
        :type opts: ConfigurationOptions, optional
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ResourceListOfSystemLog
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the list_user_logs_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.list_user_logs_with_http_info(okta_since, okta_until, okta_limit, okta_sort_order, okta_after, **kwargs)  # noqa: E501

    @validate_arguments
    def list_user_logs_with_http_info(self, okta_since : Annotated[Optional[datetime], Field(description="Lower bound of log events published property")] = None, okta_until : Annotated[Optional[datetime], Field(description="Upper bound of log events published property")] = None, okta_limit : Annotated[Optional[conint(strict=True)], Field(description="Max number of results returned")] = None, okta_sort_order : Annotated[Optional[StrictStr], Field( description="Order of events by published property. Either ASCENDING or DESCENDING")] = None, okta_after : Annotated[Optional[StrictStr], Field( description="Okta Page token")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """[BETA] ListUserLogs: Lists user logs  # noqa: E501

        Lists account related system logs for the calling user  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_user_logs_with_http_info(okta_since, okta_until, okta_limit, okta_sort_order, okta_after, async_req=True)
        >>> result = thread.get()

        :param okta_since: Lower bound of log events published property
        :type okta_since: datetime
        :param okta_until: Upper bound of log events published property
        :type okta_until: datetime
        :param okta_limit: Max number of results returned
        :type okta_limit: int
        :param okta_sort_order: Order of events by published property. Either ASCENDING or DESCENDING
        :type okta_sort_order: str
        :param okta_after: Okta Page token
        :type okta_after: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: Timeout setting. Do not use - use the opts parameter instead
        :param opts: Configuration options for this request
        :type opts: ConfigurationOptions, optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ResourceListOfSystemLog, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'okta_since',
            'okta_until',
            'okta_limit',
            'okta_sort_order',
            'okta_after'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers',
                'opts'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_user_logs" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('okta_since') is not None:  # noqa: E501
            if isinstance(_params['okta_since'], datetime):
                _query_params.append(('oktaSince', _params['okta_since'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('oktaSince', _params['okta_since']))

        if _params.get('okta_until') is not None:  # noqa: E501
            if isinstance(_params['okta_until'], datetime):
                _query_params.append(('oktaUntil', _params['okta_until'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('oktaUntil', _params['okta_until']))

        if _params.get('okta_limit') is not None:  # noqa: E501
            _query_params.append(('oktaLimit', _params['okta_limit']))

        if _params.get('okta_sort_order') is not None:  # noqa: E501
            _query_params.append(('oktaSortOrder', _params['okta_sort_order']))

        if _params.get('okta_after') is not None:  # noqa: E501
            _query_params.append(('oktaAfter', _params['okta_after']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "ResourceListOfSystemLog",
            '400': "LusidValidationProblemDetails",
        }

        return self.api_client.call_api(
            '/api/logs/me', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            opts=_params.get('opts'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
