# coding: utf-8

"""
    FINBOURNE Identity Service API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import StrictStr, Field, BaseModel, Field, StrictStr 
from finbourne_identity.models.log_geographical_context import LogGeographicalContext

class LogIpChainEntry(BaseModel):
    """
    Represents a LogIpChainEntry resource in the Okta API  # noqa: E501
    """
    ip:  Optional[StrictStr] = Field(None,alias="ip") 
    geographical_context: Optional[LogGeographicalContext] = Field(None, alias="geographicalContext")
    version:  Optional[StrictStr] = Field(None,alias="version") 
    source:  Optional[StrictStr] = Field(None,alias="source") 
    __properties = ["ip", "geographicalContext", "version", "source"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LogIpChainEntry:
        """Create an instance of LogIpChainEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of geographical_context
        if self.geographical_context:
            _dict['geographicalContext'] = self.geographical_context.to_dict()
        # set to None if ip (nullable) is None
        # and __fields_set__ contains the field
        if self.ip is None and "ip" in self.__fields_set__:
            _dict['ip'] = None

        # set to None if version (nullable) is None
        # and __fields_set__ contains the field
        if self.version is None and "version" in self.__fields_set__:
            _dict['version'] = None

        # set to None if source (nullable) is None
        # and __fields_set__ contains the field
        if self.source is None and "source" in self.__fields_set__:
            _dict['source'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LogIpChainEntry:
        """Create an instance of LogIpChainEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LogIpChainEntry.parse_obj(obj)

        _obj = LogIpChainEntry.parse_obj({
            "ip": obj.get("ip"),
            "geographical_context": LogGeographicalContext.from_dict(obj.get("geographicalContext")) if obj.get("geographicalContext") is not None else None,
            "version": obj.get("version"),
            "source": obj.get("source")
        })
        return _obj
